package org.openxma.dsl.reference.dtoassembler.model.impl;

import org.openxma.dsl.reference.base.model.impl.BaseEntityImpl;
import org.openxma.dsl.reference.dtoassembler.model.Child;
import org.openxma.dsl.reference.dtoassembler.model.Parent;

public abstract class ChildGenImpl extends BaseEntityImpl implements Child {
	protected String firstName;
	protected String lastName;
	protected Parent parent;
    
	public String getFirstName() {
		return this.firstName;
	}
	
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getLastName() {
		return this.lastName;
	}
	
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public Parent getParent() {
		return this.parent;
	}
	
	public void setParent(Parent parent) {
		if (this.parent != parent) {
			if (this.parent != null) {
				this.parent.removeChildren(this);
			}
			this.parent = parent;
			if (parent != null) {
				parent.addChildren(this);
			}
		}
	}
	
    @Override
    public String toString() {
    	StringBuilder toStringBuilder = new StringBuilder("Child [");
    	toStringBuilder.append(super.toString()).append(",");
        toStringBuilder.append("firstName=").append(getFirstName()).append(",");
        toStringBuilder.append("lastName=").append(getLastName());
        return toStringBuilder.append("]").toString();
    }
}
