package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VOByteArray</code>.
 */
public class VOByteArray extends org.openxma.dsl.platform.valueobject.ValueObjectByteArray {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VOByteArray(byte[] pByteArray) {
    	super(pByteArray);
    }

    /**
     * Create a new instance of VOByteArray or return null depending on input.
     */
    public static VOByteArray newOrNull(byte[] pByteArray) {
        if (pByteArray != null) {
            return new VOByteArray(pByteArray);
        }
        return null;
    }

}
