package org.openxma.dsl.reference.ui.styleselectors.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.graphics.Point;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of StyleSelectorsPage.
 * It implements the widgets and models of the page.
 *
 */
public abstract class StyleSelectorsPageGen extends org.openxma.dsl.platform.xma.client.DslDialogPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    ScrolledComposite scrolleddataCompositeW;
    Composite dataCompositeW;
    Composite dataComposite_set0W;
    Label dataComposite_set0_centered;
    Text txt1W;
    ISimpleWMClient txt1;
    Composite dataComposite_set1W;
    Label dataComposite_set1_centered;
    Text txt2W;
    ISimpleWMClient txt2;
    Composite dataComposite_set2W;
    Label dataComposite_set2_centered;
    Composite dataComposite_composite_0_2_0W;
    Composite dataComposite_composite_0_2_0_set0W;
    Label dataComposite_composite_0_2_0_set0_centered;
    Text txt3aW;
    ISimpleWMClient txt3a;
    Composite dataComposite_composite_0_2_0_set1W;
    Label dataComposite_composite_0_2_0_set1_centered;
    Text txt3bW;
    ISimpleWMClient txt3b;
    Composite dataComposite_composite_0_2_0_set2W;
    Label dataComposite_composite_0_2_0_set2_centered;
    Text txt3c001W;
    ISimpleWMClient txt3c001;
    Composite dataComposite_composite_0_2_0_set3W;
    Label dataComposite_composite_0_2_0_set3_centered;
    Text txt3c002W;
    ISimpleWMClient txt3c002;
    Composite dataComposite_set3W;
    Label dataComposite_set3_centered;
    Composite dataComposite_composite_0_3_0W;
    Composite dataComposite_composite_0_3_0_set0W;
    Label dataComposite_composite_0_3_0_set0_centered;
    Label lab1;
    Composite dataComposite_composite_0_3_0_set1W;
    Label dataComposite_composite_0_3_0_set1_centered;
    Label lab2;
    Composite dataComposite_composite_0_3_0_set2W;
    Label dataComposite_composite_0_3_0_set2_centered;
    Label lab3;
    Composite dataComposite_set4W;
    Label dataComposite_set4_centered;
    Composite dataComposite_composite_0_4_0W;
    Composite dataComposite_composite_0_4_0_set0W;
    Label dataComposite_composite_0_4_0_set0_centered;
    Label customer1_firstNameL;
    Text customer1_firstNameW;
    ISimpleWMClient customer1_firstName;
    Composite dataComposite_composite_0_4_0_set1W;
    Label dataComposite_composite_0_4_0_set1_centered;
    Label customer1_lastNameL;
    Text customer1_lastNameW;
    ISimpleWMClient customer1_lastName;
    Composite dataComposite_set5W;
    Label dataComposite_set5_centered;
    Composite dataComposite_composite_0_5_0W;
    Composite dataComposite_composite_0_5_0_set0W;
    Label dataComposite_composite_0_5_0_set0_centered;
    Label customer2_firstNameL;
    Label customer2_firstNameW;
    ISimpleWMClient customer2_firstName;
    Composite dataComposite_composite_0_5_0_set1W;
    Label dataComposite_composite_0_5_0_set1_centered;
    Label customer2_lastNameL;
    Label customer2_lastNameW;
    ISimpleWMClient customer2_lastName;
    Composite dataComposite_set6W;
    Label dataComposite_set6_centered;
    Composite dataComposite_composite_0_6_0W;
    Composite dataComposite_composite_0_6_0_set0W;
    Label dataComposite_composite_0_6_0_set0_centered;
    Button bt1W;
    Composite dataComposite_composite_0_6_0_set1W;
    Label dataComposite_composite_0_6_0_set1_centered;
    Button buttonWithOtherNameW;
    Composite dataComposite_composite_0_6_0_set2W;
    Label dataComposite_composite_0_6_0_set2_centered;
    Button bt2W;
    Composite actionCompositeW;
    Composite actionComposite_set0W;
    Label actionComposite_set0_centered;
    Button closeButtonW;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the StyleSelectorsPageGen.
     * @param parent the parent page
     */
    public StyleSelectorsPageGen(PageClient parent) {
        super(parent,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the StyleSelectorsPageGen.
     * @param component the component this page belongs to
     */
    public StyleSelectorsPageGen(ComponentClient component) {
        super(component,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the StyleSelectorsPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public StyleSelectorsPageGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the StyleSelectorsPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public StyleSelectorsPageGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }


    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.styleselectors.client.StyleSelectors",getGenPageLocale());
        }
        return genPageMessages;
    }

    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/dsl/reference/ui/styleselectors/StyleSelectorsPage.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        CompoundValidator compound;
        txt1 = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        txt1.setFmt(formatter);
        txt2 = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        txt2.setFmt(formatter);
        txt3a = new SimpleWMClient((short) 2, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        txt3a.setFmt(formatter);
        txt3b = new SimpleWMClient((short) 3, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        txt3b.setFmt(formatter);
        txt3c001 = new SimpleWMClient((short) 4, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        txt3c001.setFmt(formatter);
        txt3c002 = new SimpleWMClient((short) 5, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        txt3c002.setFmt(formatter);
        customer1_firstName = new SimpleWMClient((short) 6, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer1_firstName.setFmt(formatter);
        customer1_lastName = new SimpleWMClient((short) 7, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer1_lastName.setFmt(formatter);
        customer2_firstName = new SimpleWMClient((short) 8, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer2_firstName.setFmt(formatter);
        customer2_lastName = new SimpleWMClient((short) 9, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer2_lastName.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) txt1, (WModel) txt2, (WModel) txt3a, (WModel) txt3b, (WModel) txt3c001, (WModel) txt3c002, (WModel) customer1_firstName, (WModel) customer1_lastName, (WModel) customer2_firstName, (WModel) customer2_lastName };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        txt1 = null;
        txt2 = null;
        txt3a = null;
        txt3b = null;
        txt3c001 = null;
        txt3c002 = null;
        customer1_firstName = null;
        customer1_lastName = null;
        customer2_firstName = null;
        customer2_lastName = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return StyleSelectors.StyleSelectorsPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public StyleSelectors getTypedComponent() {
        return (StyleSelectors) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(getGenPageMessages().getString("StyleSelectorsPage"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite StyleSelectorsPageCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        StyleSelectorsPageCompW.setLayout(layout);

        scrolleddataCompositeW = new ScrolledComposite(StyleSelectorsPageCompW,SWT.NONE|SWT.H_SCROLL|SWT.V_SCROLL);
        scrolleddataCompositeW.setExpandHorizontal(true);
        scrolleddataCompositeW.setExpandVertical(true);
        scrolleddataCompositeW.setData("WIDGET_ID","scrolleddataCompositeW");

        dataCompositeW = new Composite(scrolleddataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        dataCompositeW.setLayout(layout);
        dataCompositeW.setData("WIDGET_ID","dataCompositeW");

        dataComposite_set0W = new Composite(dataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_set0W.setLayout(layout);
        dataComposite_set0W.setData("WIDGET_ID","dataComposite_set0W");

        dataComposite_set0_centered = new Label(dataComposite_set0W,SWT.LEFT);
        dataComposite_set0_centered.setVisible(false);
        dataComposite_set0_centered.setData("WIDGET_ID","dataComposite_set0_centered");

        txt1W = new Text(dataComposite_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        txt1W.setData("WIDGET_ID","txt1W");
        txt1W.addFocusListener(adapter);
        txt1W.addModifyListener(adapter);
        txt1W.addVerifyListener(adapter);

        dataComposite_set1W = new Composite(dataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_set1W.setLayout(layout);
        dataComposite_set1W.setData("WIDGET_ID","dataComposite_set1W");

        dataComposite_set1_centered = new Label(dataComposite_set1W,SWT.LEFT);
        dataComposite_set1_centered.setVisible(false);
        dataComposite_set1_centered.setData("WIDGET_ID","dataComposite_set1_centered");

        txt2W = new Text(dataComposite_set1W,SWT.SINGLE|SWT.BORDER|SWT.CENTER);
        txt2W.setData("WIDGET_ID","txt2W");
        txt2W.addFocusListener(adapter);
        txt2W.addModifyListener(adapter);
        txt2W.addVerifyListener(adapter);

        dataComposite_set2W = new Composite(dataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_set2W.setLayout(layout);
        dataComposite_set2W.setData("WIDGET_ID","dataComposite_set2W");

        dataComposite_set2_centered = new Label(dataComposite_set2W,SWT.LEFT);
        dataComposite_set2_centered.setVisible(false);
        dataComposite_set2_centered.setData("WIDGET_ID","dataComposite_set2_centered");

        dataComposite_composite_0_2_0W = new Composite(dataComposite_set2W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        dataComposite_composite_0_2_0W.setLayout(layout);
        dataComposite_composite_0_2_0W.setData("WIDGET_ID","dataComposite_composite_0_2_0W");

        dataComposite_composite_0_2_0_set0W = new Composite(dataComposite_composite_0_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_2_0_set0W.setLayout(layout);
        dataComposite_composite_0_2_0_set0W.setData("WIDGET_ID","dataComposite_composite_0_2_0_set0W");

        dataComposite_composite_0_2_0_set0_centered = new Label(dataComposite_composite_0_2_0_set0W,SWT.LEFT);
        dataComposite_composite_0_2_0_set0_centered.setVisible(false);
        dataComposite_composite_0_2_0_set0_centered.setData("WIDGET_ID","dataComposite_composite_0_2_0_set0_centered");

        txt3aW = new Text(dataComposite_composite_0_2_0_set0W,SWT.SINGLE|SWT.BORDER|SWT.RIGHT);
        txt3aW.setData("WIDGET_ID","txt3aW");
        txt3aW.addFocusListener(adapter);
        txt3aW.addModifyListener(adapter);
        txt3aW.addVerifyListener(adapter);

        dataComposite_composite_0_2_0_set1W = new Composite(dataComposite_composite_0_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_2_0_set1W.setLayout(layout);
        dataComposite_composite_0_2_0_set1W.setData("WIDGET_ID","dataComposite_composite_0_2_0_set1W");

        dataComposite_composite_0_2_0_set1_centered = new Label(dataComposite_composite_0_2_0_set1W,SWT.LEFT);
        dataComposite_composite_0_2_0_set1_centered.setVisible(false);
        dataComposite_composite_0_2_0_set1_centered.setData("WIDGET_ID","dataComposite_composite_0_2_0_set1_centered");

        txt3bW = new Text(dataComposite_composite_0_2_0_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        txt3bW.setData("WIDGET_ID","txt3bW");
        txt3bW.addFocusListener(adapter);
        txt3bW.addModifyListener(adapter);
        txt3bW.addVerifyListener(adapter);

        dataComposite_composite_0_2_0_set2W = new Composite(dataComposite_composite_0_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_2_0_set2W.setLayout(layout);
        dataComposite_composite_0_2_0_set2W.setData("WIDGET_ID","dataComposite_composite_0_2_0_set2W");

        dataComposite_composite_0_2_0_set2_centered = new Label(dataComposite_composite_0_2_0_set2W,SWT.LEFT);
        dataComposite_composite_0_2_0_set2_centered.setVisible(false);
        dataComposite_composite_0_2_0_set2_centered.setData("WIDGET_ID","dataComposite_composite_0_2_0_set2_centered");

        txt3c001W = new Text(dataComposite_composite_0_2_0_set2W,SWT.SINGLE|SWT.BORDER|SWT.RIGHT);
        txt3c001W.setData("WIDGET_ID","txt3c001W");
        txt3c001W.addFocusListener(adapter);
        txt3c001W.addModifyListener(adapter);
        txt3c001W.addVerifyListener(adapter);

        dataComposite_composite_0_2_0_set3W = new Composite(dataComposite_composite_0_2_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_2_0_set3W.setLayout(layout);
        dataComposite_composite_0_2_0_set3W.setData("WIDGET_ID","dataComposite_composite_0_2_0_set3W");

        dataComposite_composite_0_2_0_set3_centered = new Label(dataComposite_composite_0_2_0_set3W,SWT.LEFT);
        dataComposite_composite_0_2_0_set3_centered.setVisible(false);
        dataComposite_composite_0_2_0_set3_centered.setData("WIDGET_ID","dataComposite_composite_0_2_0_set3_centered");

        txt3c002W = new Text(dataComposite_composite_0_2_0_set3W,SWT.SINGLE|SWT.BORDER|SWT.RIGHT);
        txt3c002W.setData("WIDGET_ID","txt3c002W");
        txt3c002W.addFocusListener(adapter);
        txt3c002W.addModifyListener(adapter);
        txt3c002W.addVerifyListener(adapter);

        dataComposite_set3W = new Composite(dataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_set3W.setLayout(layout);
        dataComposite_set3W.setData("WIDGET_ID","dataComposite_set3W");

        dataComposite_set3_centered = new Label(dataComposite_set3W,SWT.LEFT);
        dataComposite_set3_centered.setVisible(false);
        dataComposite_set3_centered.setData("WIDGET_ID","dataComposite_set3_centered");

        dataComposite_composite_0_3_0W = new Composite(dataComposite_set3W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        dataComposite_composite_0_3_0W.setLayout(layout);
        dataComposite_composite_0_3_0W.setData("WIDGET_ID","dataComposite_composite_0_3_0W");

        dataComposite_composite_0_3_0_set0W = new Composite(dataComposite_composite_0_3_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_3_0_set0W.setLayout(layout);
        dataComposite_composite_0_3_0_set0W.setData("WIDGET_ID","dataComposite_composite_0_3_0_set0W");

        dataComposite_composite_0_3_0_set0_centered = new Label(dataComposite_composite_0_3_0_set0W,SWT.LEFT);
        dataComposite_composite_0_3_0_set0_centered.setVisible(false);
        dataComposite_composite_0_3_0_set0_centered.setData("WIDGET_ID","dataComposite_composite_0_3_0_set0_centered");

        lab1 = new Label(dataComposite_composite_0_3_0_set0W,SWT.LEFT);
        lab1.setText(getGenPageMessages().getString("StyleSelectorsPage.lab1"));
        lab1.setData("WIDGET_ID","lab1");

        dataComposite_composite_0_3_0_set1W = new Composite(dataComposite_composite_0_3_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_3_0_set1W.setLayout(layout);
        dataComposite_composite_0_3_0_set1W.setData("WIDGET_ID","dataComposite_composite_0_3_0_set1W");

        dataComposite_composite_0_3_0_set1_centered = new Label(dataComposite_composite_0_3_0_set1W,SWT.LEFT);
        dataComposite_composite_0_3_0_set1_centered.setVisible(false);
        dataComposite_composite_0_3_0_set1_centered.setData("WIDGET_ID","dataComposite_composite_0_3_0_set1_centered");

        lab2 = new Label(dataComposite_composite_0_3_0_set1W,SWT.RIGHT);
        lab2.setText(getGenPageMessages().getString("StyleSelectorsPage.lab2"));
        lab2.setData("WIDGET_ID","lab2");

        dataComposite_composite_0_3_0_set2W = new Composite(dataComposite_composite_0_3_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_3_0_set2W.setLayout(layout);
        dataComposite_composite_0_3_0_set2W.setData("WIDGET_ID","dataComposite_composite_0_3_0_set2W");

        dataComposite_composite_0_3_0_set2_centered = new Label(dataComposite_composite_0_3_0_set2W,SWT.LEFT);
        dataComposite_composite_0_3_0_set2_centered.setVisible(false);
        dataComposite_composite_0_3_0_set2_centered.setData("WIDGET_ID","dataComposite_composite_0_3_0_set2_centered");

        lab3 = new Label(dataComposite_composite_0_3_0_set2W,SWT.RIGHT);
        lab3.setText(getGenPageMessages().getString("StyleSelectorsPage.lab3"));
        lab3.setData("WIDGET_ID","lab3");

        dataComposite_set4W = new Composite(dataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_set4W.setLayout(layout);
        dataComposite_set4W.setData("WIDGET_ID","dataComposite_set4W");

        dataComposite_set4_centered = new Label(dataComposite_set4W,SWT.LEFT);
        dataComposite_set4_centered.setVisible(false);
        dataComposite_set4_centered.setData("WIDGET_ID","dataComposite_set4_centered");

        dataComposite_composite_0_4_0W = new Composite(dataComposite_set4W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        dataComposite_composite_0_4_0W.setLayout(layout);
        dataComposite_composite_0_4_0W.setData("WIDGET_ID","dataComposite_composite_0_4_0W");

        dataComposite_composite_0_4_0_set0W = new Composite(dataComposite_composite_0_4_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_4_0_set0W.setLayout(layout);
        dataComposite_composite_0_4_0_set0W.setData("WIDGET_ID","dataComposite_composite_0_4_0_set0W");

        dataComposite_composite_0_4_0_set0_centered = new Label(dataComposite_composite_0_4_0_set0W,SWT.LEFT);
        dataComposite_composite_0_4_0_set0_centered.setVisible(false);
        dataComposite_composite_0_4_0_set0_centered.setData("WIDGET_ID","dataComposite_composite_0_4_0_set0_centered");

        customer1_firstNameL = new Label(dataComposite_composite_0_4_0_set0W,SWT.LEFT|SWT.WRAP);
        customer1_firstNameL.setText(getGenPageMessages().getString("StyleSelectorsPage.customer1_firstNameL"));
        customer1_firstNameL.setData("WIDGET_ID","customer1_firstNameL");

        customer1_firstNameW = new Text(dataComposite_composite_0_4_0_set0W,SWT.SINGLE|SWT.BORDER|SWT.RIGHT);
        customer1_firstNameW.setToolTipText(getGenPageMessages().getString("StyleSelectorsPage.customer1_firstNameWTip"));
        customer1_firstNameW.setData("WIDGET_ID","customer1_firstNameW");
        customer1_firstNameW.addFocusListener(adapter);
        customer1_firstNameW.addModifyListener(adapter);
        customer1_firstNameW.addVerifyListener(adapter);

        dataComposite_composite_0_4_0_set1W = new Composite(dataComposite_composite_0_4_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_4_0_set1W.setLayout(layout);
        dataComposite_composite_0_4_0_set1W.setData("WIDGET_ID","dataComposite_composite_0_4_0_set1W");

        dataComposite_composite_0_4_0_set1_centered = new Label(dataComposite_composite_0_4_0_set1W,SWT.LEFT);
        dataComposite_composite_0_4_0_set1_centered.setVisible(false);
        dataComposite_composite_0_4_0_set1_centered.setData("WIDGET_ID","dataComposite_composite_0_4_0_set1_centered");

        customer1_lastNameL = new Label(dataComposite_composite_0_4_0_set1W,SWT.LEFT|SWT.WRAP);
        customer1_lastNameL.setText(getGenPageMessages().getString("StyleSelectorsPage.customer1_lastNameL"));
        customer1_lastNameL.setData("WIDGET_ID","customer1_lastNameL");

        customer1_lastNameW = new Text(dataComposite_composite_0_4_0_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer1_lastNameW.setToolTipText(getGenPageMessages().getString("StyleSelectorsPage.customer1_lastNameWTip"));
        customer1_lastNameW.setData("WIDGET_ID","customer1_lastNameW");
        customer1_lastNameW.addFocusListener(adapter);
        customer1_lastNameW.addModifyListener(adapter);
        customer1_lastNameW.addVerifyListener(adapter);

        dataComposite_set5W = new Composite(dataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_set5W.setLayout(layout);
        dataComposite_set5W.setData("WIDGET_ID","dataComposite_set5W");

        dataComposite_set5_centered = new Label(dataComposite_set5W,SWT.LEFT);
        dataComposite_set5_centered.setVisible(false);
        dataComposite_set5_centered.setData("WIDGET_ID","dataComposite_set5_centered");

        dataComposite_composite_0_5_0W = new Composite(dataComposite_set5W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        dataComposite_composite_0_5_0W.setLayout(layout);
        dataComposite_composite_0_5_0W.setData("WIDGET_ID","dataComposite_composite_0_5_0W");

        dataComposite_composite_0_5_0_set0W = new Composite(dataComposite_composite_0_5_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_5_0_set0W.setLayout(layout);
        dataComposite_composite_0_5_0_set0W.setData("WIDGET_ID","dataComposite_composite_0_5_0_set0W");

        dataComposite_composite_0_5_0_set0_centered = new Label(dataComposite_composite_0_5_0_set0W,SWT.LEFT);
        dataComposite_composite_0_5_0_set0_centered.setVisible(false);
        dataComposite_composite_0_5_0_set0_centered.setData("WIDGET_ID","dataComposite_composite_0_5_0_set0_centered");

        customer2_firstNameL = new Label(dataComposite_composite_0_5_0_set0W,SWT.LEFT|SWT.WRAP);
        customer2_firstNameL.setText(getGenPageMessages().getString("StyleSelectorsPage.customer2_firstNameL"));
        customer2_firstNameL.setData("WIDGET_ID","customer2_firstNameL");

        customer2_firstNameW = new Label(dataComposite_composite_0_5_0_set0W,SWT.RIGHT);
        customer2_firstNameW.setToolTipText(getGenPageMessages().getString("StyleSelectorsPage.customer2_firstNameWTip"));
        customer2_firstNameW.setData("WIDGET_ID","customer2_firstNameW");

        dataComposite_composite_0_5_0_set1W = new Composite(dataComposite_composite_0_5_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_5_0_set1W.setLayout(layout);
        dataComposite_composite_0_5_0_set1W.setData("WIDGET_ID","dataComposite_composite_0_5_0_set1W");

        dataComposite_composite_0_5_0_set1_centered = new Label(dataComposite_composite_0_5_0_set1W,SWT.LEFT);
        dataComposite_composite_0_5_0_set1_centered.setVisible(false);
        dataComposite_composite_0_5_0_set1_centered.setData("WIDGET_ID","dataComposite_composite_0_5_0_set1_centered");

        customer2_lastNameL = new Label(dataComposite_composite_0_5_0_set1W,SWT.LEFT|SWT.WRAP);
        customer2_lastNameL.setText(getGenPageMessages().getString("StyleSelectorsPage.customer2_lastNameL"));
        customer2_lastNameL.setData("WIDGET_ID","customer2_lastNameL");

        customer2_lastNameW = new Label(dataComposite_composite_0_5_0_set1W,SWT.LEFT);
        customer2_lastNameW.setToolTipText(getGenPageMessages().getString("StyleSelectorsPage.customer2_lastNameWTip"));
        customer2_lastNameW.setData("WIDGET_ID","customer2_lastNameW");

        dataComposite_set6W = new Composite(dataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_set6W.setLayout(layout);
        dataComposite_set6W.setData("WIDGET_ID","dataComposite_set6W");

        dataComposite_set6_centered = new Label(dataComposite_set6W,SWT.LEFT);
        dataComposite_set6_centered.setVisible(false);
        dataComposite_set6_centered.setData("WIDGET_ID","dataComposite_set6_centered");

        dataComposite_composite_0_6_0W = new Composite(dataComposite_set6W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        dataComposite_composite_0_6_0W.setLayout(layout);
        dataComposite_composite_0_6_0W.setData("WIDGET_ID","dataComposite_composite_0_6_0W");

        dataComposite_composite_0_6_0_set0W = new Composite(dataComposite_composite_0_6_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_6_0_set0W.setLayout(layout);
        dataComposite_composite_0_6_0_set0W.setData("WIDGET_ID","dataComposite_composite_0_6_0_set0W");

        dataComposite_composite_0_6_0_set0_centered = new Label(dataComposite_composite_0_6_0_set0W,SWT.LEFT);
        dataComposite_composite_0_6_0_set0_centered.setVisible(false);
        dataComposite_composite_0_6_0_set0_centered.setData("WIDGET_ID","dataComposite_composite_0_6_0_set0_centered");

        bt1W = new Button(dataComposite_composite_0_6_0_set0W, SWT.PUSH|SWT.RIGHT);
        bt1W.setText(getGenPageMessages().getString("StyleSelectorsPage.bt1W"));
        bt1W.setData("WIDGET_ID","bt1W");
        bt1W.addSelectionListener(adapter);

        dataComposite_composite_0_6_0_set1W = new Composite(dataComposite_composite_0_6_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_6_0_set1W.setLayout(layout);
        dataComposite_composite_0_6_0_set1W.setData("WIDGET_ID","dataComposite_composite_0_6_0_set1W");

        dataComposite_composite_0_6_0_set1_centered = new Label(dataComposite_composite_0_6_0_set1W,SWT.LEFT);
        dataComposite_composite_0_6_0_set1_centered.setVisible(false);
        dataComposite_composite_0_6_0_set1_centered.setData("WIDGET_ID","dataComposite_composite_0_6_0_set1_centered");

        buttonWithOtherNameW = new Button(dataComposite_composite_0_6_0_set1W, SWT.PUSH|SWT.CENTER);
        buttonWithOtherNameW.setText(getGenPageMessages().getString("StyleSelectorsPage.buttonWithOtherNameW"));
        buttonWithOtherNameW.setData("WIDGET_ID","buttonWithOtherNameW");
        buttonWithOtherNameW.addSelectionListener(adapter);

        dataComposite_composite_0_6_0_set2W = new Composite(dataComposite_composite_0_6_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        dataComposite_composite_0_6_0_set2W.setLayout(layout);
        dataComposite_composite_0_6_0_set2W.setData("WIDGET_ID","dataComposite_composite_0_6_0_set2W");

        dataComposite_composite_0_6_0_set2_centered = new Label(dataComposite_composite_0_6_0_set2W,SWT.LEFT);
        dataComposite_composite_0_6_0_set2_centered.setVisible(false);
        dataComposite_composite_0_6_0_set2_centered.setData("WIDGET_ID","dataComposite_composite_0_6_0_set2_centered");

        bt2W = new Button(dataComposite_composite_0_6_0_set2W, SWT.PUSH|SWT.LEFT);
        bt2W.setText(getGenPageMessages().getString("StyleSelectorsPage.bt2W"));
        bt2W.setData("WIDGET_ID","bt2W");
        bt2W.addSelectionListener(adapter);

        actionCompositeW = new Composite(StyleSelectorsPageCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        actionCompositeW.setLayout(layout);
        actionCompositeW.setData("WIDGET_ID","actionCompositeW");

        actionComposite_set0W = new Composite(actionCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        actionComposite_set0W.setLayout(layout);
        actionComposite_set0W.setData("WIDGET_ID","actionComposite_set0W");

        actionComposite_set0_centered = new Label(actionComposite_set0W,SWT.LEFT);
        actionComposite_set0_centered.setVisible(false);
        actionComposite_set0_centered.setData("WIDGET_ID","actionComposite_set0_centered");

        closeButtonW = new Button(actionComposite_set0W, SWT.PUSH|SWT.CENTER);
        closeButtonW.setText(getGenPageMessages().getString("StyleSelectorsPage.closeButtonW"));
        closeButtonW.setData("WIDGET_ID","closeButtonW");
        closeButtonW.addSelectionListener(adapter);

        widgets = new Control[] { scrolleddataCompositeW, dataCompositeW, dataComposite_set0W, dataComposite_set0_centered, txt1W, dataComposite_set1W, dataComposite_set1_centered, txt2W, dataComposite_set2W, dataComposite_set2_centered, dataComposite_composite_0_2_0W, dataComposite_composite_0_2_0_set0W, dataComposite_composite_0_2_0_set0_centered, txt3aW, dataComposite_composite_0_2_0_set1W, dataComposite_composite_0_2_0_set1_centered, txt3bW, dataComposite_composite_0_2_0_set2W, dataComposite_composite_0_2_0_set2_centered, txt3c001W, dataComposite_composite_0_2_0_set3W, dataComposite_composite_0_2_0_set3_centered, txt3c002W, dataComposite_set3W, dataComposite_set3_centered, dataComposite_composite_0_3_0W, dataComposite_composite_0_3_0_set0W, dataComposite_composite_0_3_0_set0_centered, lab1, dataComposite_composite_0_3_0_set1W, dataComposite_composite_0_3_0_set1_centered, lab2, dataComposite_composite_0_3_0_set2W, dataComposite_composite_0_3_0_set2_centered, lab3, dataComposite_set4W, dataComposite_set4_centered, dataComposite_composite_0_4_0W, dataComposite_composite_0_4_0_set0W, dataComposite_composite_0_4_0_set0_centered, customer1_firstNameL, customer1_firstNameW, dataComposite_composite_0_4_0_set1W, dataComposite_composite_0_4_0_set1_centered, customer1_lastNameL, customer1_lastNameW, dataComposite_set5W, dataComposite_set5_centered, dataComposite_composite_0_5_0W, dataComposite_composite_0_5_0_set0W, dataComposite_composite_0_5_0_set0_centered, customer2_firstNameL, customer2_firstNameW, dataComposite_composite_0_5_0_set1W, dataComposite_composite_0_5_0_set1_centered, customer2_lastNameL, customer2_lastNameW, dataComposite_set6W, dataComposite_set6_centered, dataComposite_composite_0_6_0W, dataComposite_composite_0_6_0_set0W, dataComposite_composite_0_6_0_set0_centered, bt1W, dataComposite_composite_0_6_0_set1W, dataComposite_composite_0_6_0_set1_centered, buttonWithOtherNameW, dataComposite_composite_0_6_0_set2W, dataComposite_composite_0_6_0_set2_centered, bt2W, actionCompositeW, actionComposite_set0W, actionComposite_set0_centered, closeButtonW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(actionCompositeW,scaler.convertYToCurrent(0),SWT.TOP);
        scrolleddataCompositeW.setLayoutData(data);


        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        dataComposite_set0W.setLayoutData(data);
        lastControl=dataComposite_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_set1W.setLayoutData(data);
        lastControl=dataComposite_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_set2W.setLayoutData(data);
        lastControl=dataComposite_set2W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_set3W.setLayoutData(data);
        lastControl=dataComposite_set3W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_set4W.setLayoutData(data);
        lastControl=dataComposite_set4W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_set5W.setLayoutData(data);
        lastControl=dataComposite_set5W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_set6W.setLayoutData(data);
        lastControl=dataComposite_set6W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        txt1W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_set1_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        txt2W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_set2_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_2_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_2_0_set0W.setLayoutData(data);
        lastControl=dataComposite_composite_0_2_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_2_0_set1W.setLayoutData(data);
        lastControl=dataComposite_composite_0_2_0_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_2_0_set2W.setLayoutData(data);
        lastControl=dataComposite_composite_0_2_0_set2W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_2_0_set3W.setLayoutData(data);
        lastControl=dataComposite_composite_0_2_0_set3W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_2_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_2_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        txt3aW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_2_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_2_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        txt3bW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_2_0_set2_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_2_0_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        txt3c001W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_2_0_set3_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_2_0_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        txt3c002W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_set3_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_3_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_3_0_set0W.setLayoutData(data);
        lastControl=dataComposite_composite_0_3_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_3_0_set1W.setLayoutData(data);
        lastControl=dataComposite_composite_0_3_0_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_3_0_set2W.setLayoutData(data);
        lastControl=dataComposite_composite_0_3_0_set2W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_3_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_3_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        lab1.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_3_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_3_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        lab2.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_3_0_set2_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_3_0_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        lab3.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_set4_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_4_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_4_0_set0W.setLayoutData(data);
        lastControl=dataComposite_composite_0_4_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_4_0_set1W.setLayoutData(data);
        lastControl=dataComposite_composite_0_4_0_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_4_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(150));
        data.top = new FormAttachment(dataComposite_composite_0_4_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer1_firstNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(175);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(153));
        data.top = new FormAttachment(dataComposite_composite_0_4_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer1_firstNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_4_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(150));
        data.top = new FormAttachment(dataComposite_composite_0_4_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer1_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(350);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(153));
        data.top = new FormAttachment(dataComposite_composite_0_4_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer1_lastNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_set5_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_5_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_5_0_set0W.setLayoutData(data);
        lastControl=dataComposite_composite_0_5_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_5_0_set1W.setLayoutData(data);
        lastControl=dataComposite_composite_0_5_0_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_5_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(150));
        data.top = new FormAttachment(dataComposite_composite_0_5_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_firstNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(175);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(153));
        data.top = new FormAttachment(dataComposite_composite_0_5_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_firstNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_5_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(150));
        data.top = new FormAttachment(dataComposite_composite_0_5_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(350);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(153));
        data.top = new FormAttachment(dataComposite_composite_0_5_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer2_lastNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_set6_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_6_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_6_0_set0W.setLayoutData(data);
        lastControl=dataComposite_composite_0_6_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_6_0_set1W.setLayoutData(data);
        lastControl=dataComposite_composite_0_6_0_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        dataComposite_composite_0_6_0_set2W.setLayoutData(data);
        lastControl=dataComposite_composite_0_6_0_set2W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_6_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_6_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        bt1W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_6_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_6_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        buttonWithOtherNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        dataComposite_composite_0_6_0_set2_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(dataComposite_composite_0_6_0_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        bt2W.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        actionCompositeW.setLayoutData(data);

        lastControl=null;
        data = new FormData();
            data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        actionComposite_set0W.setLayoutData(data);
        lastControl=actionComposite_set0W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        actionComposite_set0_centered.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(actionComposite_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        closeButtonW.setLayoutData(data);


        scrolleddataCompositeW.setContent(dataCompositeW);
        Point size = dataCompositeW.computeSize(SWT.DEFAULT,SWT.DEFAULT);
        scrolleddataCompositeW.setMinSize(size);

        if(getDialog()==this) {
            shell.setTabList(new Control[] { StyleSelectorsPageCompW });
        }
        tabOrder = new Control[2];
        tabOrder[0] = scrolleddataCompositeW;
        tabOrder[1] = actionCompositeW;
        StyleSelectorsPageCompW.setTabList(tabOrder);
        tabOrder = new Control[7];
        tabOrder[0] = dataComposite_set0W;
        tabOrder[1] = dataComposite_set1W;
        tabOrder[2] = dataComposite_set2W;
        tabOrder[3] = dataComposite_set3W;
        tabOrder[4] = dataComposite_set4W;
        tabOrder[5] = dataComposite_set5W;
        tabOrder[6] = dataComposite_set6W;
        dataCompositeW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = txt1W;
        dataComposite_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = txt2W;
        dataComposite_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = dataComposite_composite_0_2_0W;
        dataComposite_set2W.setTabList(tabOrder);
        tabOrder = new Control[4];
        tabOrder[0] = dataComposite_composite_0_2_0_set0W;
        tabOrder[1] = dataComposite_composite_0_2_0_set1W;
        tabOrder[2] = dataComposite_composite_0_2_0_set2W;
        tabOrder[3] = dataComposite_composite_0_2_0_set3W;
        dataComposite_composite_0_2_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = txt3aW;
        dataComposite_composite_0_2_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = txt3bW;
        dataComposite_composite_0_2_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = txt3c001W;
        dataComposite_composite_0_2_0_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = txt3c002W;
        dataComposite_composite_0_2_0_set3W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = dataComposite_composite_0_3_0W;
        dataComposite_set3W.setTabList(tabOrder);
        tabOrder = new Control[3];
        tabOrder[0] = dataComposite_composite_0_3_0_set0W;
        tabOrder[1] = dataComposite_composite_0_3_0_set1W;
        tabOrder[2] = dataComposite_composite_0_3_0_set2W;
        dataComposite_composite_0_3_0W.setTabList(tabOrder);
        tabOrder = new Control[0];
        dataComposite_composite_0_3_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[0];
        dataComposite_composite_0_3_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[0];
        dataComposite_composite_0_3_0_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = dataComposite_composite_0_4_0W;
        dataComposite_set4W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = dataComposite_composite_0_4_0_set0W;
        tabOrder[1] = dataComposite_composite_0_4_0_set1W;
        dataComposite_composite_0_4_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer1_firstNameW;
        dataComposite_composite_0_4_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer1_lastNameW;
        dataComposite_composite_0_4_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = dataComposite_composite_0_5_0W;
        dataComposite_set5W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = dataComposite_composite_0_5_0_set0W;
        tabOrder[1] = dataComposite_composite_0_5_0_set1W;
        dataComposite_composite_0_5_0W.setTabList(tabOrder);
        tabOrder = new Control[0];
        dataComposite_composite_0_5_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[0];
        dataComposite_composite_0_5_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = dataComposite_composite_0_6_0W;
        dataComposite_set6W.setTabList(tabOrder);
        tabOrder = new Control[3];
        tabOrder[0] = dataComposite_composite_0_6_0_set0W;
        tabOrder[1] = dataComposite_composite_0_6_0_set1W;
        tabOrder[2] = dataComposite_composite_0_6_0_set2W;
        dataComposite_composite_0_6_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = bt1W;
        dataComposite_composite_0_6_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = buttonWithOtherNameW;
        dataComposite_composite_0_6_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = bt2W;
        dataComposite_composite_0_6_0_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = actionComposite_set0W;
        actionCompositeW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = closeButtonW;
        actionComposite_set0W.setTabList(tabOrder);
        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(640), scaler.convertYToCurrent(480));
        }
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        scrolleddataCompositeW = null;
        dataCompositeW = null;
        dataComposite_set0W = null;
        dataComposite_set0_centered = null;
        txt1W = null;
        dataComposite_set1W = null;
        dataComposite_set1_centered = null;
        txt2W = null;
        dataComposite_set2W = null;
        dataComposite_set2_centered = null;
        dataComposite_composite_0_2_0W = null;
        dataComposite_composite_0_2_0_set0W = null;
        dataComposite_composite_0_2_0_set0_centered = null;
        txt3aW = null;
        dataComposite_composite_0_2_0_set1W = null;
        dataComposite_composite_0_2_0_set1_centered = null;
        txt3bW = null;
        dataComposite_composite_0_2_0_set2W = null;
        dataComposite_composite_0_2_0_set2_centered = null;
        txt3c001W = null;
        dataComposite_composite_0_2_0_set3W = null;
        dataComposite_composite_0_2_0_set3_centered = null;
        txt3c002W = null;
        dataComposite_set3W = null;
        dataComposite_set3_centered = null;
        dataComposite_composite_0_3_0W = null;
        dataComposite_composite_0_3_0_set0W = null;
        dataComposite_composite_0_3_0_set0_centered = null;
        lab1 = null;
        dataComposite_composite_0_3_0_set1W = null;
        dataComposite_composite_0_3_0_set1_centered = null;
        lab2 = null;
        dataComposite_composite_0_3_0_set2W = null;
        dataComposite_composite_0_3_0_set2_centered = null;
        lab3 = null;
        dataComposite_set4W = null;
        dataComposite_set4_centered = null;
        dataComposite_composite_0_4_0W = null;
        dataComposite_composite_0_4_0_set0W = null;
        dataComposite_composite_0_4_0_set0_centered = null;
        customer1_firstNameL = null;
        customer1_firstNameW = null;
        dataComposite_composite_0_4_0_set1W = null;
        dataComposite_composite_0_4_0_set1_centered = null;
        customer1_lastNameL = null;
        customer1_lastNameW = null;
        dataComposite_set5W = null;
        dataComposite_set5_centered = null;
        dataComposite_composite_0_5_0W = null;
        dataComposite_composite_0_5_0_set0W = null;
        dataComposite_composite_0_5_0_set0_centered = null;
        customer2_firstNameL = null;
        customer2_firstNameW = null;
        dataComposite_composite_0_5_0_set1W = null;
        dataComposite_composite_0_5_0_set1_centered = null;
        customer2_lastNameL = null;
        customer2_lastNameW = null;
        dataComposite_set6W = null;
        dataComposite_set6_centered = null;
        dataComposite_composite_0_6_0W = null;
        dataComposite_composite_0_6_0_set0W = null;
        dataComposite_composite_0_6_0_set0_centered = null;
        bt1W = null;
        dataComposite_composite_0_6_0_set1W = null;
        dataComposite_composite_0_6_0_set1_centered = null;
        buttonWithOtherNameW = null;
        dataComposite_composite_0_6_0_set2W = null;
        dataComposite_composite_0_6_0_set2_centered = null;
        bt2W = null;
        actionCompositeW = null;
        actionComposite_set0W = null;
        actionComposite_set0_centered = null;
        closeButtonW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        txt1W.setData(txt1.getUIDelegate());
        txt1.getUIDelegate().attachUI(txt1W,null);
        txt2W.setData(txt2.getUIDelegate());
        txt2.getUIDelegate().attachUI(txt2W,null);
        txt3aW.setData(txt3a.getUIDelegate());
        txt3a.getUIDelegate().attachUI(txt3aW,null);
        txt3bW.setData(txt3b.getUIDelegate());
        txt3b.getUIDelegate().attachUI(txt3bW,null);
        txt3c001W.setData(txt3c001.getUIDelegate());
        txt3c001.getUIDelegate().attachUI(txt3c001W,null);
        txt3c002W.setData(txt3c002.getUIDelegate());
        txt3c002.getUIDelegate().attachUI(txt3c002W,null);
        customer1_firstNameW.setData(customer1_firstName.getUIDelegate());
        customer1_firstName.getUIDelegate().attachUI(customer1_firstNameW,customer1_firstNameL);
        customer1_lastNameW.setData(customer1_lastName.getUIDelegate());
        customer1_lastName.getUIDelegate().attachUI(customer1_lastNameW,customer1_lastNameL);
        customer2_firstNameW.setData(customer2_firstName.getUIDelegate());
        customer2_firstName.getUIDelegate().attachUI(customer2_firstNameW,customer2_firstNameL);
        customer2_lastNameW.setData(customer2_lastName.getUIDelegate());
        customer2_lastName.getUIDelegate().attachUI(customer2_lastNameW,customer2_lastNameL);
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {

        customer1_firstName.setMandatory(true);
        customer1_lastName.setMandatory(true);
        customer2_firstName.setMandatory(true);
        customer2_lastName.setMandatory(true);
    }

    /**
     * Method called to start the DialogPage.
     */
    public boolean invoke() {
        load(null);
        return super.invoke();
    }

    /**
     * This method will be called every time the StyleSelectorsPage becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
        if (event.widget == bt1W) {
            bt1WEvent();
        } else if (event.widget == buttonWithOtherNameW) {
            buttonWithOtherNameWEvent();
        } else if (event.widget == bt2W) {
            bt2WEvent();
        } else if (event.widget == closeButtonW) {
            closePage(event);
        }
    }

    /**
     * This method will be called every time the user clicks on bt1W.
     */
    abstract protected void bt1WEvent();

    /**
     * This method will be called every time the user clicks on buttonWithOtherNameW.
     */
    abstract protected void buttonWithOtherNameWEvent();

    /**
     * This method will be called every time the user clicks on bt2W.
     */
    abstract protected void bt2WEvent();


    protected void load(SelectionEvent event) {
        newRemoteCall("load").execute();
    }

    abstract protected void closePage(SelectionEvent event);

}
